unit USBUniquekeyLib;

interface

uses Windows;

const
{$IFDEF WIN64}
  USBUniquekeyDLLName = 'USBUniquekey64.dll';
{$ELSE}
  // ̺귯 DLL ̸Դϴ.
  USBUniquekeyDLLName = 'USBUniquekey.dll';
{$ENDIF}
  UNIQUE_USB_KEY_TYPE_STRONG = $1;
  UNIQUE_USB_KEY_TYPE_VENDOR = $2;
  UNIQUE_USB_KEY_TYPE_VENDOR_AND_PRODUCT = $3;

  NVALID_PORT_NUMBER = ($FFFFFFFF);
  INVALID_DISK_SIZE = ($FFFFFFFFFFFFFFFF);

type
  PHYSICAL_DEVICE_INQUIRY_ID = Record
    VendorId: Array [0 .. 49] of AnsiChar;
    ProductId: Array [0 .. 49] of AnsiChar;
    ProductRevisionLevel: Array [0 .. 9] of AnsiChar;
  end;

  PPHYSICAL_DEVICE_INQUIRY_ID = ^PHYSICAL_DEVICE_INQUIRY_ID;

function GetUSBHardwareUniqueKey(UniqueUSBKeyType: ULONG; DetectPort: ULONG;
  DrivePath: PWideChar; UniqueKey: PAnsiChar): Boolean; cdecl;
  external USBUniquekeyDLLName;

function GetDeviceIndex(DrivePath: PWideChar): Integer; cdecl;
  external USBUniquekeyDLLName;

function GetPhysicalDeviceID(DrivePath: PWideChar;
  pPhysicalInquiryId: PPHYSICAL_DEVICE_INQUIRY_ID): Boolean; cdecl;
  external USBUniquekeyDLLName;

function IsBusTypeUSB(DrivePath: PWideChar; pRemovableMedia: PBOOL): Boolean;
  cdecl; external USBUniquekeyDLLName;

function GetDiskSize(DrivePath: PWideChar): UInt64; cdecl;
  external USBUniquekeyDLLName;

function GetUSBPortNumber(DeviceIndex: ULONG): ULONG; cdecl;
  external USBUniquekeyDLLName;

function GetUSBHardwareSerialNumber(DeviceIndex: ULONG; SerialNumber: PWideChar;
  uSerialNumberLength: ULONG): Boolean; cdecl; external USBUniquekeyDLLName;

implementation

end.
