unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    cbxUSBDriveList: TComboBox;
    btnBuy: TButton;
    edtUniqueKeyStrong: TEdit;
    edtUniqueKeyVendor: TEdit;
    edtUniqueKeyVendorProduct: TEdit;
    edtVendor: TEdit;
    edtProduct: TEdit;
    edtHardwareSerialNumber: TEdit;
    edtVersion: TEdit;
    procedure btnBuyClick(Sender: TObject);
    procedure cbxUSBDriveListChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateUSBDriveList;
    procedure DisplayUSBInformation;
  public
    { Public declarations }
    procedure WMDeviceChange(var Message: TMessage); message WM_DEVICECHANGE;
  end;

var
  Form1: TForm1;

implementation
  uses USBUniquekeyLib, ShellApi;

{$R *.dfm}


procedure TForm1.btnBuyClick(Sender: TObject);
begin
  ShellExecute(Self.Handle, 'open',
    'http://ohsoft.net/update/website.php?product=usbuniquekey', nil,
    nil, SW_SHOW);
end;

procedure TForm1.cbxUSBDriveListChange(Sender: TObject);
begin
  if cbxUSBDriveList.ItemIndex <> -1 then
  begin
    DisplayUSBInformation;
  end;
end;

procedure TForm1.DisplayUSBInformation;
var
  DeviceIndex: Integer;

  DrivePath: WideString;
  UniqueKey: Array [0 .. 32] of AnsiChar;
  SerialNumber: Array [0 .. 49] of WideChar;

  DeviceID: PHYSICAL_DEVICE_INQUIRY_ID;
begin
  DrivePath := Copy(cbxUSBDriveList.Items[cbxUSBDriveList.ItemIndex], 1, 2);

  FillMemory(@UniqueKey, SizeOf(UniqueKey), 0);
  if GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_STRONG, 0, PWideChar(DrivePath),
    @UniqueKey) = True then
    edtUniqueKeyStrong.Text := StrPas(UniqueKey)
  else
    edtUniqueKeyStrong.Text := 'failed';

  if GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_VENDOR, 0, PWideChar(DrivePath),
    @UniqueKey) = True then
    edtUniqueKeyVendor.Text := StrPas(UniqueKey)
  else
    edtUniqueKeyVendor.Text := 'failed';

  if GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_VENDOR_AND_PRODUCT, 0,
    PWideChar(DrivePath), @UniqueKey) = True then
    edtUniqueKeyVendorProduct.Text := StrPas(UniqueKey)
  else
    edtUniqueKeyVendorProduct.Text := 'failed';

  ZeroMemory(@DeviceID, SizeOf(PHYSICAL_DEVICE_INQUIRY_ID));
  if GetPhysicalDeviceID(PWideChar(DrivePath), @DeviceID) = True then
  begin
    edtVendor.Text := DeviceID.VendorId;
    edtProduct.Text := DeviceID.ProductId;
    edtVersion.Text := DeviceID.ProductRevisionLevel;
  end
  else
  begin
    edtVendor.Text := 'failed';
    edtProduct.Text := 'failed';
    edtVendor.Text := 'failed';
  end;

  edtHardwareSerialNumber.Text := 'failed';

  DeviceIndex := GetDeviceIndex(PWideChar(DrivePath));
  if DeviceIndex <> -1 then
  begin
    if GetUSBHardwareSerialNumber(DeviceIndex, SerialNumber,
      Length(SerialNumber) * SizeOf(WideChar)) = True then
    begin
      edtHardwareSerialNumber.Text := SerialNumber;
    end;
  end;
end;

procedure TForm1.UpdateUSBDriveList;
var
  RemovableMedia: BOOL;

  Letter: WideChar;
  DrivePath: WideString;
begin
  cbxUSBDriveList.Clear;

  for Letter := 'C' to 'Z' do
  begin
    RemovableMedia := False;
    DrivePath := Letter;
    DrivePath := DrivePath + ':';
    if IsBusTypeUSB(PWideChar(DrivePath), @RemovableMedia) = True then
    begin
      cbxUSBDriveList.AddItem(DrivePath, nil);
    end;
  end;

  if cbxUSBDriveList.Items.Count > 0 then
    cbxUSBDriveList.ItemIndex := 0;

  cbxUSBDriveListChange(Self);
end;

procedure TForm1.WMDeviceChange(var Message: TMessage);
begin
  UpdateUSBDriveList;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UpdateUSBDriveList;
end;

end.
