#include <Windows.h>
#include "..\Include\USBUniquekey.h"

#pragma comment(lib, "Lib\\USBUniquekey.lib")

int main()
{
	WCHAR Letter;
	WCHAR DrivePath[3];
	
	BOOL bRemovableMedia;

	CHAR UniqueKey[MAX_UNIQUE_KEY_LENGTH + 1];
	WCHAR USBHardwareSerialNumber[MAX_USB_HARDWARE_SERIALNUMBER_LENGTH + 1];

	PHYSICAL_DEVICE_INQUIRY_ID DeviceID;

	int iDeviceIndex;

	memset(DrivePath, 0, sizeof(DrivePath));

	for (Letter = L'C'; Letter <= 'Z'; Letter++)
	{
		DrivePath[0] = Letter;
		DrivePath[1] = L':';
		
		if (IsBusTypeUSB(DrivePath, &bRemovableMedia) == TRUE)
		{
			if (bRemovableMedia == TRUE)
			{
				printf("DrivePath: %ws\n\n", DrivePath);

				memset(UniqueKey, 0, sizeof(UniqueKey));
				if (GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_STRONG, FALSE, DrivePath, UniqueKey) == TRUE)
				{
					printf("UniqueKey Strong: %s\n", UniqueKey);
				}
				else
				{
					printf("failed to UniqueKey Strong\n");
				}

				if (GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_VENDOR, FALSE, DrivePath, UniqueKey) == TRUE)
				{
					printf("UniqueKey Vendor: %s\n", UniqueKey);
				}
				else
				{
					printf("failed to UniqueKey Vendor\n");
				}

				if (GetUSBHardwareUniqueKey(UNIQUE_USB_KEY_TYPE_VENDOR_AND_PRODUCT, FALSE, DrivePath, UniqueKey) == TRUE)
				{
					printf("UniqueKey Vendor&Product: %s\n", UniqueKey);
				}
				else
				{
					printf("failed to UniqueKey Vendor&Product\n");
				}

				printf("\n");

				memset(&DeviceID, 0, sizeof(DeviceID));
				if (GetPhysicalDeviceID(DrivePath, &DeviceID) == TRUE)
				{
					printf("VendorID:%s\n", DeviceID.VendorId);
					printf("ProductId:%s\n", DeviceID.ProductId);
					printf("ProductRevisionLevel:%s\n", DeviceID.ProductRevisionLevel);
				}
				else
				{
					printf("GetPhysicalDeviceID failed\n");
				}

				iDeviceIndex = GetDeviceIndex(DrivePath);
				if (iDeviceIndex != (-1))
				{
					printf("\n");

					memset(USBHardwareSerialNumber, 0, sizeof(USBHardwareSerialNumber));
					if (GetUSBHardwareSerialNumber(iDeviceIndex,
						USBHardwareSerialNumber, sizeof(USBHardwareSerialNumber)) == TRUE)
					{
						printf("USBHardwareSerialNumber:%ws\n", USBHardwareSerialNumber);
					}
					else
					{
						printf("failed GetUSBHardwareSerialNumber");
					}
				}
				printf("\n\n");
			}
		}
	}

	return 0;
}